#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"


#define MAX_COLOR 255
char *load (lua_State *L, const char *fname, int *number, int x, int y, char* myString);

int main(void) {
    lua_State *L = luaL_newstate();   /* opens Lua */
    luaL_openlibs(L);             /* opens the standard libraries */
    char filename[] = "C:/Lua C and C++/workspace/functionFile.lua";
    int number = 0;
    int x = 5;
    int y = 6;
    char *a = malloc(100);
    strcpy(a, "Hello to ");
    char * resultString = load(L, filename, &number, x, y, a);

    printf("number is %d\n", number);
    printf("The String is %s\n",  resultString);
    free(a);
    free(resultString);
    return 0;
}


char *load (lua_State *L, const char *fname, int *number, int x, int y, char* myString) {


	if (luaL_loadfile(L, fname) || lua_pcall(L, 0, 0, 0)) {
		luaL_error(L, "cannot run config file: %s", lua_tostring(L, -1));
	}

	lua_getglobal(L, "modifyData");
	lua_pushnumber(L, x);
	lua_pushnumber(L, y);
	lua_pushstring(L, myString);

	if (lua_pcall(L, 3, 2, 0) != 0) {
		luaL_error(L, "error in function ");
	}

	int z = lua_tointeger(L, -2);
    printf("the number is %d\n", z);
    *number = z;

    myString = lua_tostring(L, -1);
	printf("the string is %s\n", myString);

	lua_pop(L, 1);
	lua_pop(L, 1);
	return myString;
}
